<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TypeFichiersControle StructType
 * @subpackage Structs
 */
class TypeFichiersControle extends AbstractStructBase
{
    /**
     * The Fichier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\Fichier[]
     */
    public $Fichier;
    /**
     * Constructor method for TypeFichiersControle
     * @uses TypeFichiersControle::setFichier()
     * @param \StructType\Fichier[] $fichier
     */
    public function __construct(array $fichier = array())
    {
        $this
            ->setFichier($fichier);
    }
    /**
     * Get Fichier value
     * @return \StructType\Fichier[]
     */
    public function getFichier()
    {
        return $this->Fichier;
    }
    /**
     * This method is responsible for validating the values passed to the setFichier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFichier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFichierForArrayConstraintsFromSetFichier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $typeFichiersControleFichierItem) {
            // validation for constraint: itemType
            if (!$typeFichiersControleFichierItem instanceof \StructType\Fichier) {
                $invalidValues[] = is_object($typeFichiersControleFichierItem) ? get_class($typeFichiersControleFichierItem) : sprintf('%s(%s)', gettype($typeFichiersControleFichierItem), var_export($typeFichiersControleFichierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Fichier property can only contain items of type \StructType\Fichier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Fichier value
     * @throws \InvalidArgumentException
     * @param \StructType\Fichier[] $fichier
     * @return \StructType\TypeFichiersControle
     */
    public function setFichier(array $fichier = array())
    {
        // validation for constraint: array
        if ('' !== ($fichierArrayErrorMessage = self::validateFichierForArrayConstraintsFromSetFichier($fichier))) {
            throw new \InvalidArgumentException($fichierArrayErrorMessage, __LINE__);
        }
        $this->Fichier = $fichier;
        return $this;
    }
    /**
     * Add item to Fichier value
     * @throws \InvalidArgumentException
     * @param \StructType\Fichier $item
     * @return \StructType\TypeFichiersControle
     */
    public function addToFichier(\StructType\Fichier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Fichier) {
            throw new \InvalidArgumentException(sprintf('The Fichier property can only contain items of type \StructType\Fichier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Fichier[] = $item;
        return $this;
    }
}
